diff -ruN tarsnap-autoconf-1.0.33/libcperciva/alg/sha256.c tarsnap-autoconf-1.0.34/libcperciva/alg/sha256.c
--- tarsnap-autoconf-1.0.33/libcperciva/alg/sha256.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/alg/sha256.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,436 @@
+#include <stdint.h>
+#include <string.h>
+
+#include "sysendian.h"
+
+#include "sha256.h"
+
+/*
+ * Encode a length len/4 vector of (uint32_t) into a length len vector of
+ * (uint8_t) in big-endian form.  Assumes len is a multiple of 4.
+ */
+static void
+be32enc_vect(uint8_t *dst, const uint32_t *src, size_t len)
+{
+	size_t i;
+
+	for (i = 0; i < len / 4; i++)
+		be32enc(dst + i * 4, src[i]);
+}
+
+/*
+ * Decode a big-endian length len vector of (uint8_t) into a length
+ * len/4 vector of (uint32_t).  Assumes len is a multiple of 4.
+ */
+static void
+be32dec_vect(uint32_t *dst, const uint8_t *src, size_t len)
+{
+	size_t i;
+
+	for (i = 0; i < len / 4; i++)
+		dst[i] = be32dec(src + i * 4);
+}
+
+/* Elementary functions used by SHA256 */
+#define Ch(x, y, z)	((x & (y ^ z)) ^ z)
+#define Maj(x, y, z)	((x & (y | z)) | (y & z))
+#define SHR(x, n)	(x >> n)
+#define ROTR(x, n)	((x >> n) | (x << (32 - n)))
+#define S0(x)		(ROTR(x, 2) ^ ROTR(x, 13) ^ ROTR(x, 22))
+#define S1(x)		(ROTR(x, 6) ^ ROTR(x, 11) ^ ROTR(x, 25))
+#define s0(x)		(ROTR(x, 7) ^ ROTR(x, 18) ^ SHR(x, 3))
+#define s1(x)		(ROTR(x, 17) ^ ROTR(x, 19) ^ SHR(x, 10))
+
+/* SHA256 round function */
+#define RND(a, b, c, d, e, f, g, h, k)			\
+	t0 = h + S1(e) + Ch(e, f, g) + k;		\
+	t1 = S0(a) + Maj(a, b, c);			\
+	d += t0;					\
+	h  = t0 + t1;
+
+/* Adjusted round function for rotating state */
+#define RNDr(S, W, i, k)			\
+	RND(S[(64 - i) % 8], S[(65 - i) % 8],	\
+	    S[(66 - i) % 8], S[(67 - i) % 8],	\
+	    S[(68 - i) % 8], S[(69 - i) % 8],	\
+	    S[(70 - i) % 8], S[(71 - i) % 8],	\
+	    W[i] + k)
+
+/*
+ * SHA256 block compression function.  The 256-bit state is transformed via
+ * the 512-bit input block to produce a new state.
+ */
+static void
+SHA256_Transform(uint32_t * state, const uint8_t block[64])
+{
+	uint32_t W[64];
+	uint32_t S[8];
+	uint32_t t0, t1;
+	int i;
+
+	/* 1. Prepare message schedule W. */
+	be32dec_vect(W, block, 64);
+	for (i = 16; i < 64; i++)
+		W[i] = s1(W[i - 2]) + W[i - 7] + s0(W[i - 15]) + W[i - 16];
+
+	/* 2. Initialize working variables. */
+	memcpy(S, state, 32);
+
+	/* 3. Mix. */
+	RNDr(S, W, 0, 0x428a2f98);
+	RNDr(S, W, 1, 0x71374491);
+	RNDr(S, W, 2, 0xb5c0fbcf);
+	RNDr(S, W, 3, 0xe9b5dba5);
+	RNDr(S, W, 4, 0x3956c25b);
+	RNDr(S, W, 5, 0x59f111f1);
+	RNDr(S, W, 6, 0x923f82a4);
+	RNDr(S, W, 7, 0xab1c5ed5);
+	RNDr(S, W, 8, 0xd807aa98);
+	RNDr(S, W, 9, 0x12835b01);
+	RNDr(S, W, 10, 0x243185be);
+	RNDr(S, W, 11, 0x550c7dc3);
+	RNDr(S, W, 12, 0x72be5d74);
+	RNDr(S, W, 13, 0x80deb1fe);
+	RNDr(S, W, 14, 0x9bdc06a7);
+	RNDr(S, W, 15, 0xc19bf174);
+	RNDr(S, W, 16, 0xe49b69c1);
+	RNDr(S, W, 17, 0xefbe4786);
+	RNDr(S, W, 18, 0x0fc19dc6);
+	RNDr(S, W, 19, 0x240ca1cc);
+	RNDr(S, W, 20, 0x2de92c6f);
+	RNDr(S, W, 21, 0x4a7484aa);
+	RNDr(S, W, 22, 0x5cb0a9dc);
+	RNDr(S, W, 23, 0x76f988da);
+	RNDr(S, W, 24, 0x983e5152);
+	RNDr(S, W, 25, 0xa831c66d);
+	RNDr(S, W, 26, 0xb00327c8);
+	RNDr(S, W, 27, 0xbf597fc7);
+	RNDr(S, W, 28, 0xc6e00bf3);
+	RNDr(S, W, 29, 0xd5a79147);
+	RNDr(S, W, 30, 0x06ca6351);
+	RNDr(S, W, 31, 0x14292967);
+	RNDr(S, W, 32, 0x27b70a85);
+	RNDr(S, W, 33, 0x2e1b2138);
+	RNDr(S, W, 34, 0x4d2c6dfc);
+	RNDr(S, W, 35, 0x53380d13);
+	RNDr(S, W, 36, 0x650a7354);
+	RNDr(S, W, 37, 0x766a0abb);
+	RNDr(S, W, 38, 0x81c2c92e);
+	RNDr(S, W, 39, 0x92722c85);
+	RNDr(S, W, 40, 0xa2bfe8a1);
+	RNDr(S, W, 41, 0xa81a664b);
+	RNDr(S, W, 42, 0xc24b8b70);
+	RNDr(S, W, 43, 0xc76c51a3);
+	RNDr(S, W, 44, 0xd192e819);
+	RNDr(S, W, 45, 0xd6990624);
+	RNDr(S, W, 46, 0xf40e3585);
+	RNDr(S, W, 47, 0x106aa070);
+	RNDr(S, W, 48, 0x19a4c116);
+	RNDr(S, W, 49, 0x1e376c08);
+	RNDr(S, W, 50, 0x2748774c);
+	RNDr(S, W, 51, 0x34b0bcb5);
+	RNDr(S, W, 52, 0x391c0cb3);
+	RNDr(S, W, 53, 0x4ed8aa4a);
+	RNDr(S, W, 54, 0x5b9cca4f);
+	RNDr(S, W, 55, 0x682e6ff3);
+	RNDr(S, W, 56, 0x748f82ee);
+	RNDr(S, W, 57, 0x78a5636f);
+	RNDr(S, W, 58, 0x84c87814);
+	RNDr(S, W, 59, 0x8cc70208);
+	RNDr(S, W, 60, 0x90befffa);
+	RNDr(S, W, 61, 0xa4506ceb);
+	RNDr(S, W, 62, 0xbef9a3f7);
+	RNDr(S, W, 63, 0xc67178f2);
+
+	/* 4. Mix local working variables into global state. */
+	for (i = 0; i < 8; i++)
+		state[i] += S[i];
+
+	/* Clean the stack. */
+	memset(W, 0, 256);
+	memset(S, 0, 32);
+	t0 = t1 = 0;
+}
+
+static uint8_t PAD[64] = {
+	0x80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+};
+
+/* Add padding and terminating bit-count. */
+static void
+SHA256_Pad(SHA256_CTX * ctx)
+{
+	uint8_t len[8];
+	uint32_t r, plen;
+
+	/*
+	 * Convert length to a vector of bytes -- we do this now rather
+	 * than later because the length will change after we pad.
+	 */
+	be32enc_vect(len, ctx->count, 8);
+
+	/* Add 1--64 bytes so that the resulting length is 56 mod 64. */
+	r = (ctx->count[1] >> 3) & 0x3f;
+	plen = (r < 56) ? (56 - r) : (120 - r);
+	SHA256_Update(ctx, PAD, (size_t)plen);
+
+	/* Add the terminating bit-count. */
+	SHA256_Update(ctx, len, 8);
+}
+
+/**
+ * SHA256_Init(ctx):
+ * Initialize the SHA256 context ${ctx}.
+ */
+void
+SHA256_Init(SHA256_CTX * ctx)
+{
+
+	/* Zero bits processed so far. */
+	ctx->count[0] = ctx->count[1] = 0;
+
+	/* Magic initialization constants. */
+	ctx->state[0] = 0x6A09E667;
+	ctx->state[1] = 0xBB67AE85;
+	ctx->state[2] = 0x3C6EF372;
+	ctx->state[3] = 0xA54FF53A;
+	ctx->state[4] = 0x510E527F;
+	ctx->state[5] = 0x9B05688C;
+	ctx->state[6] = 0x1F83D9AB;
+	ctx->state[7] = 0x5BE0CD19;
+}
+
+/**
+ * SHA256_Update(ctx, in, len):
+ * Input ${len} bytes from ${in} into the SHA256 context ${ctx}.
+ */
+void
+SHA256_Update(SHA256_CTX * ctx, const void *in, size_t len)
+{
+	uint32_t bitlen[2];
+	uint32_t r;
+	const uint8_t *src = in;
+
+	/* Return immediately if we have nothing to do. */
+	if (len == 0)
+		return;
+
+	/* Number of bytes left in the buffer from previous updates. */
+	r = (ctx->count[1] >> 3) & 0x3f;
+
+	/* Convert the length into a number of bits. */
+	bitlen[1] = ((uint32_t)len) << 3;
+	bitlen[0] = (uint32_t)(len >> 29);
+
+	/* Update number of bits. */
+	if ((ctx->count[1] += bitlen[1]) < bitlen[1])
+		ctx->count[0]++;
+	ctx->count[0] += bitlen[0];
+
+	/* Handle the case where we don't need to perform any transforms. */
+	if (len < 64 - r) {
+		memcpy(&ctx->buf[r], src, len);
+		return;
+	}
+
+	/* Finish the current block. */
+	memcpy(&ctx->buf[r], src, 64 - r);
+	SHA256_Transform(ctx->state, ctx->buf);
+	src += 64 - r;
+	len -= 64 - r;
+
+	/* Perform complete blocks. */
+	while (len >= 64) {
+		SHA256_Transform(ctx->state, src);
+		src += 64;
+		len -= 64;
+	}
+
+	/* Copy left over data into buffer. */
+	memcpy(ctx->buf, src, len);
+}
+
+/**
+ * SHA256_Final(digest, ctx):
+ * Output the SHA256 hash of the data input to the context ${ctx} into the
+ * buffer ${digest}.
+ */
+void
+SHA256_Final(uint8_t digest[32], SHA256_CTX * ctx)
+{
+
+	/* Add padding. */
+	SHA256_Pad(ctx);
+
+	/* Write the hash. */
+	be32enc_vect(digest, ctx->state, 32);
+
+	/* Clear the context state. */
+	memset((void *)ctx, 0, sizeof(*ctx));
+}
+
+/**
+ * SHA256_Buf(in, len, digest):
+ * Compute the SHA256 hash of ${len} bytes from $in} and write it to ${digest}.
+ */
+void
+SHA256_Buf(const void * in, size_t len, uint8_t digest[32])
+{
+	SHA256_CTX ctx;
+
+	SHA256_Init(&ctx);
+	SHA256_Update(&ctx, in, len);
+	SHA256_Final(digest, &ctx);
+}
+
+/**
+ * HMAC_SHA256_Init(ctx, K, Klen):
+ * Initialize the HMAC-SHA256 context ${ctx} with ${Klen} bytes of key from
+ * ${K}.
+ */
+void
+HMAC_SHA256_Init(HMAC_SHA256_CTX * ctx, const void * _K, size_t Klen)
+{
+	uint8_t pad[64];
+	uint8_t khash[32];
+	const uint8_t * K = _K;
+	size_t i;
+
+	/* If Klen > 64, the key is really SHA256(K). */
+	if (Klen > 64) {
+		SHA256_Init(&ctx->ictx);
+		SHA256_Update(&ctx->ictx, K, Klen);
+		SHA256_Final(khash, &ctx->ictx);
+		K = khash;
+		Klen = 32;
+	}
+
+	/* Inner SHA256 operation is SHA256(K xor [block of 0x36] || data). */
+	SHA256_Init(&ctx->ictx);
+	memset(pad, 0x36, 64);
+	for (i = 0; i < Klen; i++)
+		pad[i] ^= K[i];
+	SHA256_Update(&ctx->ictx, pad, 64);
+
+	/* Outer SHA256 operation is SHA256(K xor [block of 0x5c] || hash). */
+	SHA256_Init(&ctx->octx);
+	memset(pad, 0x5c, 64);
+	for (i = 0; i < Klen; i++)
+		pad[i] ^= K[i];
+	SHA256_Update(&ctx->octx, pad, 64);
+
+	/* Clean the stack. */
+	memset(khash, 0, 32);
+	memset(pad, 0, 64);
+}
+
+/**
+ * HMAC_SHA256_Update(ctx, in, len):
+ * Input ${len} bytes from ${in} into the HMAC-SHA256 context ${ctx}.
+ */
+void
+HMAC_SHA256_Update(HMAC_SHA256_CTX * ctx, const void *in, size_t len)
+{
+
+	/* Feed data to the inner SHA256 operation. */
+	SHA256_Update(&ctx->ictx, in, len);
+}
+
+/**
+ * HMAC_SHA256_Final(digest, ctx):
+ * Output the HMAC-SHA256 of the data input to the context ${ctx} into the
+ * buffer ${digest}.
+ */
+void
+HMAC_SHA256_Final(uint8_t digest[32], HMAC_SHA256_CTX * ctx)
+{
+	uint8_t ihash[32];
+
+	/* Finish the inner SHA256 operation. */
+	SHA256_Final(ihash, &ctx->ictx);
+
+	/* Feed the inner hash to the outer SHA256 operation. */
+	SHA256_Update(&ctx->octx, ihash, 32);
+
+	/* Finish the outer SHA256 operation. */
+	SHA256_Final(digest, &ctx->octx);
+
+	/* Clean the stack. */
+	memset(ihash, 0, 32);
+}
+
+/**
+ * HMAC_SHA256_Buf(K, Klen, in, len, digest):
+ * Compute the HMAC-SHA256 of ${len} bytes from ${in} using the key ${K} of
+ * length ${Klen}, and write the result to ${digest}.
+ */
+void
+HMAC_SHA256_Buf(const void * K, size_t Klen, const void * in, size_t len,
+    uint8_t digest[32])
+{
+	HMAC_SHA256_CTX ctx;
+
+	HMAC_SHA256_Init(&ctx, K, Klen);
+	HMAC_SHA256_Update(&ctx, in, len);
+	HMAC_SHA256_Final(digest, &ctx);
+}
+
+/**
+ * PBKDF2_SHA256(passwd, passwdlen, salt, saltlen, c, buf, dkLen):
+ * Compute PBKDF2(passwd, salt, c, dkLen) using HMAC-SHA256 as the PRF, and
+ * write the output to buf.  The value dkLen must be at most 32 * (2^32 - 1).
+ */
+void
+PBKDF2_SHA256(const uint8_t * passwd, size_t passwdlen, const uint8_t * salt,
+    size_t saltlen, uint64_t c, uint8_t * buf, size_t dkLen)
+{
+	HMAC_SHA256_CTX PShctx, hctx;
+	size_t i;
+	uint8_t ivec[4];
+	uint8_t U[32];
+	uint8_t T[32];
+	uint64_t j;
+	int k;
+	size_t clen;
+
+	/* Compute HMAC state after processing P and S. */
+	HMAC_SHA256_Init(&PShctx, passwd, passwdlen);
+	HMAC_SHA256_Update(&PShctx, salt, saltlen);
+
+	/* Iterate through the blocks. */
+	for (i = 0; i * 32 < dkLen; i++) {
+		/* Generate INT(i + 1). */
+		be32enc(ivec, (uint32_t)(i + 1));
+
+		/* Compute U_1 = PRF(P, S || INT(i)). */
+		memcpy(&hctx, &PShctx, sizeof(HMAC_SHA256_CTX));
+		HMAC_SHA256_Update(&hctx, ivec, 4);
+		HMAC_SHA256_Final(U, &hctx);
+
+		/* T_i = U_1 ... */
+		memcpy(T, U, 32);
+
+		for (j = 2; j <= c; j++) {
+			/* Compute U_j. */
+			HMAC_SHA256_Init(&hctx, passwd, passwdlen);
+			HMAC_SHA256_Update(&hctx, U, 32);
+			HMAC_SHA256_Final(U, &hctx);
+
+			/* ... xor U_j ... */
+			for (k = 0; k < 32; k++)
+				T[k] ^= U[k];
+		}
+
+		/* Copy as many bytes as necessary into buf. */
+		clen = dkLen - i * 32;
+		if (clen > 32)
+			clen = 32;
+		memcpy(&buf[i * 32], T, clen);
+	}
+
+	/* Clean PShctx, since we never called _Final on it. */
+	memset(&PShctx, 0, sizeof(HMAC_SHA256_CTX));
+}
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/alg/sha256.h tarsnap-autoconf-1.0.34/libcperciva/alg/sha256.h
--- tarsnap-autoconf-1.0.33/libcperciva/alg/sha256.h	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/alg/sha256.h	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,95 @@
+#ifndef _SHA256_H_
+#define _SHA256_H_
+
+#include <stddef.h>
+#include <stdint.h>
+
+/*
+ * Use #defines in order to avoid namespace collisions with anyone else's
+ * SHA256 code (e.g., the code in OpenSSL).
+ */
+#define SHA256_Init libcperciva_SHA256_Init
+#define SHA256_Update libcperciva_SHA256_Update
+#define SHA256_Final libcperciva_SHA256_Final
+#define SHA256_Buf libcperciva_SHA256_Buf
+#define SHA256_CTX libcperciva_SHA256_CTX
+#define HMAC_SHA256_Init libcperciva_HMAC_SHA256_Init
+#define HMAC_SHA256_Update libcperciva_HMAC_SHA256_Update
+#define HMAC_SHA256_Final libcperciva_HMAC_SHA256_Final
+#define HMAC_SHA256_Buf libcperciva_HMAC_SHA256_Buf
+#define HMAC_SHA256_CTX libcperciva_HMAC_SHA256_CTX
+
+/* Context structure for SHA256 operations. */
+typedef struct {
+	uint32_t state[8];
+	uint32_t count[2];
+	uint8_t buf[64];
+} SHA256_CTX;
+
+/**
+ * SHA256_Init(ctx):
+ * Initialize the SHA256 context ${ctx}.
+ */
+void SHA256_Init(SHA256_CTX *);
+
+/**
+ * SHA256_Update(ctx, in, len):
+ * Input ${len} bytes from ${in} into the SHA256 context ${ctx}.
+ */
+void SHA256_Update(SHA256_CTX *, const void *, size_t);
+
+/**
+ * SHA256_Final(digest, ctx):
+ * Output the SHA256 hash of the data input to the context ${ctx} into the
+ * buffer ${digest}.
+ */
+void SHA256_Final(uint8_t[32], SHA256_CTX *);
+
+/**
+ * SHA256_Buf(in, len, digest):
+ * Compute the SHA256 hash of ${len} bytes from $in} and write it to ${digest}.
+ */
+void SHA256_Buf(const void *, size_t, uint8_t[32]);
+
+/* Context structure for HMAC-SHA256 operations. */
+typedef struct {
+	SHA256_CTX ictx;
+	SHA256_CTX octx;
+} HMAC_SHA256_CTX;
+
+/**
+ * HMAC_SHA256_Init(ctx, K, Klen):
+ * Initialize the HMAC-SHA256 context ${ctx} with ${Klen} bytes of key from
+ * ${K}.
+ */
+void HMAC_SHA256_Init(HMAC_SHA256_CTX *, const void *, size_t);
+
+/**
+ * HMAC_SHA256_Update(ctx, in, len):
+ * Input ${len} bytes from ${in} into the HMAC-SHA256 context ${ctx}.
+ */
+void HMAC_SHA256_Update(HMAC_SHA256_CTX *, const void *, size_t);
+
+/**
+ * HMAC_SHA256_Final(digest, ctx):
+ * Output the HMAC-SHA256 of the data input to the context ${ctx} into the
+ * buffer ${digest}.
+ */
+void HMAC_SHA256_Final(uint8_t[32], HMAC_SHA256_CTX *);
+
+/**
+ * HMAC_SHA256_Buf(K, Klen, in, len, digest):
+ * Compute the HMAC-SHA256 of ${len} bytes from ${in} using the key ${K} of
+ * length ${Klen}, and write the result to ${digest}.
+ */
+void HMAC_SHA256_Buf(const void *, size_t, const void *, size_t, uint8_t[32]);
+
+/**
+ * PBKDF2_SHA256(passwd, passwdlen, salt, saltlen, c, buf, dkLen):
+ * Compute PBKDF2(passwd, salt, c, dkLen) using HMAC-SHA256 as the PRF, and
+ * write the output to buf.  The value dkLen must be at most 32 * (2^32 - 1).
+ */
+void PBKDF2_SHA256(const uint8_t *, size_t, const uint8_t *, size_t,
+    uint64_t, uint8_t *, size_t);
+
+#endif /* !_SHA256_H_ */
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/crypto/crypto_aesctr.c tarsnap-autoconf-1.0.34/libcperciva/crypto/crypto_aesctr.c
--- tarsnap-autoconf-1.0.33/libcperciva/crypto/crypto_aesctr.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/crypto/crypto_aesctr.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,124 @@
+#include <stdint.h>
+#include <stdlib.h>
+
+#include <openssl/aes.h>
+
+#include "sysendian.h"
+
+#include "crypto_aesctr.h"
+
+struct crypto_aesctr {
+	const AES_KEY * key;
+	uint64_t nonce;
+	uint64_t bytectr;
+	uint8_t buf[16];
+};
+
+/**
+ * crypto_aesctr_init(key, nonce):
+ * Prepare to encrypt/decrypt data with AES in CTR mode, using the provided
+ * expanded key and nonce.  The key provided must remain valid for the
+ * lifetime of the stream.
+ */
+struct crypto_aesctr *
+crypto_aesctr_init(const AES_KEY * key, uint64_t nonce)
+{
+	struct crypto_aesctr * stream;
+
+	/* Allocate memory. */
+	if ((stream = malloc(sizeof(struct crypto_aesctr))) == NULL)
+		goto err0;
+
+	/* Initialize values. */
+	stream->key = key;
+	stream->nonce = nonce;
+	stream->bytectr = 0;
+
+	/* Success! */
+	return (stream);
+
+err0:
+	/* Failure! */
+	return (NULL);
+}
+
+/**
+ * crypto_aesctr_stream(stream, inbuf, outbuf, buflen):
+ * Generate the next ${buflen} bytes of the AES-CTR stream and xor them with
+ * bytes from ${inbuf}, writing the result into ${outbuf}.  If the buffers
+ * ${inbuf} and ${outbuf} overlap, they must be identical.
+ */
+void
+crypto_aesctr_stream(struct crypto_aesctr * stream, const uint8_t * inbuf,
+    uint8_t * outbuf, size_t buflen)
+{
+	uint8_t pblk[16];
+	size_t pos;
+	int bytemod;
+
+	for (pos = 0; pos < buflen; pos++) {
+		/* How far through the buffer are we? */
+		bytemod = stream->bytectr % 16;
+
+		/* Generate a block of cipherstream if needed. */
+		if (bytemod == 0) {
+			be64enc(pblk, stream->nonce);
+			be64enc(pblk + 8, stream->bytectr / 16);
+			AES_encrypt(pblk, stream->buf, stream->key);
+		}
+
+		/* Encrypt a byte. */
+		outbuf[pos] = inbuf[pos] ^ stream->buf[bytemod];
+
+		/* Move to the next byte of cipherstream. */
+		stream->bytectr += 1;
+	}
+}
+
+/**
+ * crypto_aesctr_free(stream):
+ * Free the provided stream object.
+ */
+void
+crypto_aesctr_free(struct crypto_aesctr * stream)
+{
+	int i;
+
+	/* Be compatible with free(NULL). */
+	if (stream == NULL)
+		return;
+
+	/* Zero potentially sensitive information. */
+	for (i = 0; i < 16; i++)
+		stream->buf[i] = 0;
+	stream->bytectr = stream->nonce = 0;
+
+	/* Free the stream. */
+	free(stream);
+}
+
+/**
+ * crypto_aesctr_buf(key, nonce, inbuf, outbuf, buflen):
+ * Equivalent to init(key, nonce); stream(inbuf, outbuf, buflen); free.
+ */
+void
+crypto_aesctr_buf(const AES_KEY * key, uint64_t nonce,
+    const uint8_t * inbuf, uint8_t * outbuf, size_t buflen)
+{
+	struct crypto_aesctr stream_rec;
+	struct crypto_aesctr * stream = &stream_rec;
+	int i;
+
+	/* Initialize values. */
+	stream->key = key;
+	stream->nonce = nonce;
+	stream->bytectr = 0;
+
+	/* Perform the encryption. */
+	crypto_aesctr_stream(stream, inbuf, outbuf, buflen);
+
+	/* Zero potentially sensitive information. */
+	for (i = 0; i < 16; i++)
+		stream->buf[i] = 0;
+	stream->bytectr = stream->nonce = 0;
+}
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/crypto/crypto_aesctr.h tarsnap-autoconf-1.0.34/libcperciva/crypto/crypto_aesctr.h
--- tarsnap-autoconf-1.0.33/libcperciva/crypto/crypto_aesctr.h	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/crypto/crypto_aesctr.h	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,39 @@
+#ifndef _CRYPTO_AESCTR_H_
+#define _CRYPTO_AESCTR_H_
+
+#include <stddef.h>
+#include <stdint.h>
+
+#include <openssl/aes.h>
+
+/**
+ * crypto_aesctr_init(key, nonce):
+ * Prepare to encrypt/decrypt data with AES in CTR mode, using the provided
+ * expanded key and nonce.  The key provided must remain valid for the
+ * lifetime of the stream.
+ */
+struct crypto_aesctr * crypto_aesctr_init(const AES_KEY *, uint64_t);
+
+/**
+ * crypto_aesctr_stream(stream, inbuf, outbuf, buflen):
+ * Generate the next ${buflen} bytes of the AES-CTR stream and xor them with
+ * bytes from ${inbuf}, writing the result into ${outbuf}.  If the buffers
+ * ${inbuf} and ${outbuf} overlap, they must be identical.
+ */
+void crypto_aesctr_stream(struct crypto_aesctr *, const uint8_t *,
+    uint8_t *, size_t);
+
+/**
+ * crypto_aesctr_free(stream):
+ * Free the provided stream object.
+ */
+void crypto_aesctr_free(struct crypto_aesctr *);
+
+/**
+ * crypto_aesctr_buf(key, nonce, inbuf, outbuf, buflen):
+ * Equivalent to init(key, nonce); stream(inbuf, outbuf, buflen); free.
+ */
+void crypto_aesctr_buf(const AES_KEY *, uint64_t,
+    const uint8_t *, uint8_t *, size_t);
+
+#endif /* !_CRYPTO_AESCTR_H_ */
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/crypto/crypto_dh.c tarsnap-autoconf-1.0.34/libcperciva/crypto/crypto_dh.c
--- tarsnap-autoconf-1.0.33/libcperciva/crypto/crypto_dh.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/crypto/crypto_dh.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,293 @@
+#include <stdint.h>
+#include <string.h>
+
+#include <openssl/bn.h>
+#include <openssl/err.h>
+
+#include "warnp.h"
+
+#include "crypto_entropy.h"
+#include "crypto_dh_group14.h"
+
+#include "crypto_dh.h"
+
+static int blinded_modexp(uint8_t r[CRYPTO_DH_PUBLEN], BIGNUM * a,
+    const uint8_t priv[CRYPTO_DH_PRIVLEN]);
+
+/* Big-endian representation of 2^256. */
+static uint8_t two_exp_256[] = {
+	0x01,
+	0x00, 0x00, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00
+};
+
+/**
+ * blinded_modexp(r, a, priv):
+ * Compute ${r} = ${a}^(2^258 + ${priv}), where ${r} and ${priv} are treated
+ * as big-endian integers; and avoid leaking timing data in this process.
+ */
+static int
+blinded_modexp(uint8_t r[CRYPTO_DH_PUBLEN], BIGNUM * a,
+    const uint8_t priv[CRYPTO_DH_PRIVLEN])
+{
+	BIGNUM * two_exp_256_bn;
+	BIGNUM * priv_bn;
+	uint8_t blinding[CRYPTO_DH_PRIVLEN];
+	BIGNUM * blinding_bn;
+	BIGNUM * priv_blinded;
+	BIGNUM * m_bn;
+	BN_CTX * ctx;
+	BIGNUM * r1;
+	BIGNUM * r2;
+	size_t rlen;
+
+	/* Construct 2^256 in BN representation. */
+	if ((two_exp_256_bn = BN_bin2bn(two_exp_256, 33, NULL)) == NULL) {
+		warn0("%s", ERR_error_string(ERR_get_error(), NULL));
+		goto err0;
+	}
+
+	/* Construct 2^258 + ${priv} in BN representation. */
+	if ((priv_bn = BN_bin2bn(priv, CRYPTO_DH_PRIVLEN, NULL)) == NULL) {
+		warn0("%s", ERR_error_string(ERR_get_error(), NULL));
+		goto err1;
+	}
+	if ((!BN_add(priv_bn, priv_bn, two_exp_256_bn)) ||
+	    (!BN_add(priv_bn, priv_bn, two_exp_256_bn)) ||
+	    (!BN_add(priv_bn, priv_bn, two_exp_256_bn)) ||
+	    (!BN_add(priv_bn, priv_bn, two_exp_256_bn))) {
+		warn0("%s", ERR_error_string(ERR_get_error(), NULL));
+		goto err2;
+	}
+
+	/* Generate blinding exponent. */
+	if (crypto_entropy_read(blinding, CRYPTO_DH_PRIVLEN))
+		goto err2;
+	if ((blinding_bn = BN_bin2bn(blinding,
+	    CRYPTO_DH_PRIVLEN, NULL)) == NULL) {
+		warn0("%s", ERR_error_string(ERR_get_error(), NULL));
+		goto err2;
+	}
+	if (!BN_add(blinding_bn, blinding_bn, two_exp_256_bn)) {
+		warn0("%s", ERR_error_string(ERR_get_error(), NULL));
+		goto err3;
+	}
+
+	/* Generate blinded exponent. */
+	if ((priv_blinded = BN_new()) == NULL) {
+		warn0("%s", ERR_error_string(ERR_get_error(), NULL));
+		goto err3;
+	}
+	if (!BN_sub(priv_blinded, priv_bn, blinding_bn)) {
+		warn0("%s", ERR_error_string(ERR_get_error(), NULL));
+		goto err4;
+	}
+
+	/* Construct group #14 modulus in BN representation. */
+	if ((m_bn = BN_bin2bn(crypto_dh_group14, 256, NULL)) == NULL) {
+		warn0("%s", ERR_error_string(ERR_get_error(), NULL));
+		goto err4;
+	}
+
+	/* Allocate BN context. */
+	if ((ctx = BN_CTX_new()) == NULL) {
+		warn0("%s", ERR_error_string(ERR_get_error(), NULL));
+		goto err5;
+	}
+
+	/* Allocate space for storing results of exponentiations. */
+	if ((r1 = BN_new()) == NULL) {
+		warn0("%s", ERR_error_string(ERR_get_error(), NULL));
+		goto err6;
+	}
+	if ((r2 = BN_new()) == NULL) {
+		warn0("%s", ERR_error_string(ERR_get_error(), NULL));
+		goto err7;
+	}
+
+	/* Perform modular exponentiations. */
+	if (!BN_mod_exp(r1, a, blinding_bn, m_bn, ctx)) {
+		warn0("%s", ERR_error_string(ERR_get_error(), NULL));
+		goto err8;
+	}
+	if (!BN_mod_exp(r2, a, priv_blinded, m_bn, ctx)) {
+		warn0("%s", ERR_error_string(ERR_get_error(), NULL));
+		goto err8;
+	}
+
+	/* Compute final result and export to big-endian integer format. */
+	if (!BN_mod_mul(r1, r1, r2, m_bn, ctx)) {
+		warn0("%s", ERR_error_string(ERR_get_error(), NULL));
+		goto err8;
+	}
+	rlen = BN_num_bytes(r1);
+	if (rlen > CRYPTO_DH_PUBLEN) {
+		warn0("Exponent result too large!");
+		goto err8;
+	}
+	memset(r, 0, CRYPTO_DH_PUBLEN - rlen);
+	BN_bn2bin(r1, r + CRYPTO_DH_PUBLEN - rlen);
+
+	/* Free space allocated by BN_new. */
+	BN_free(r2);
+	BN_free(r1);
+
+	/* Free context allocated by BN_CTX_new. */
+	BN_CTX_free(ctx);
+
+	/* Free space allocated by BN_bin2bn. */
+	BN_free(m_bn);
+
+	/* Free space allocated by BN_new. */
+	BN_free(priv_blinded);
+
+	/* Free space allocated by BN_bin2bn. */
+	BN_free(blinding_bn);
+	BN_free(priv_bn);
+	BN_free(two_exp_256_bn);
+
+	/* Success! */
+	return (0);
+
+err8:
+	BN_free(r2);
+err7:
+	BN_free(r1);
+err6:
+	BN_CTX_free(ctx);
+err5:
+	BN_free(m_bn);
+err4:
+	BN_free(priv_blinded);
+err3:
+	BN_free(blinding_bn);
+err2:
+	BN_free(priv_bn);
+err1:
+	BN_free(two_exp_256_bn);
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * crypto_dh_generate_pub(pub, priv):
+ * Compute ${pub} equal to 2^(2^258 + ${priv}) in Diffie-Hellman group #14.
+ */
+int
+crypto_dh_generate_pub(uint8_t pub[CRYPTO_DH_PUBLEN],
+    const uint8_t priv[CRYPTO_DH_PRIVLEN])
+{
+	BIGNUM * two;
+
+	/* Generate BN representation for 2. */
+	if ((two = BN_new()) == NULL) {
+		warn0("%s", ERR_error_string(ERR_get_error(), NULL));
+		goto err0;
+	}
+	if (!BN_set_word(two, 2)) {
+		warn0("%s", ERR_error_string(ERR_get_error(), NULL));
+		goto err1;
+	}
+
+	/* Compute pub = two^(2^258 + priv). */
+	if (blinded_modexp(pub, two, priv))
+		goto err1;
+
+	/* Free storage allocated by BN_new. */
+	BN_free(two);
+
+	/* Success! */
+	return (0);
+
+err1:
+	BN_free(two);
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * crypto_dh_generate(pub, priv):
+ * Generate a 256-bit private key ${priv}, and compute ${pub} equal to
+ * 2^(2^258 + ${priv}) mod p where p is the Diffie-Hellman group #14 modulus.
+ * Both values are stored as big-endian integers.
+ */
+int
+crypto_dh_generate(uint8_t pub[CRYPTO_DH_PUBLEN],
+    uint8_t priv[CRYPTO_DH_PRIVLEN])
+{
+
+	/* Generate a random private key. */
+	if (crypto_entropy_read(priv, CRYPTO_DH_PRIVLEN))
+		goto err0;
+
+	/* Compute the public key. */
+	if (crypto_dh_generate_pub(pub, priv))
+		goto err0;
+
+	/* Success! */
+	return (0);
+
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * crypto_dh_compute(pub, priv, key):
+ * In the Diffie-Hellman group #14, compute ${pub}^(2^258 + ${priv}) and
+ * write the result into ${key}.  All values are big-endian.  Note that the
+ * value ${pub} is the public key produced the call to crypto_dh_generate
+ * made by the *other* participant in the key exchange.
+ */
+int
+crypto_dh_compute(const uint8_t pub[CRYPTO_DH_PUBLEN],
+    const uint8_t priv[CRYPTO_DH_PRIVLEN], uint8_t key[CRYPTO_DH_KEYLEN])
+{
+	BIGNUM * a;
+
+	/* Convert ${pub} into BN representation. */
+	if ((a = BN_bin2bn(pub, CRYPTO_DH_PUBLEN, NULL)) == NULL) {
+		warn0("%s", ERR_error_string(ERR_get_error(), NULL));
+		goto err0;
+	}
+
+	/* Compute key = pub^(2^258 + priv). */
+	if (blinded_modexp(key, a, priv))
+		goto err1;
+
+	/* Free storage allocated by BN_bin2bn. */
+	BN_free(a);
+
+	/* Success! */
+	return (0);
+
+err1:
+	BN_free(a);
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * crypto_dh_sanitycheck(pub):
+ * Sanity-check the Diffie-Hellman public value ${pub} by checking that it
+ * is less than the group #14 modulus.  Return 0 if sane, -1 if insane.
+ */
+int
+crypto_dh_sanitycheck(const uint8_t pub[CRYPTO_DH_PUBLEN])
+{
+
+	if (memcmp(pub, crypto_dh_group14, 256) >= 0)
+		return (-1);
+
+	/* Value is sane. */
+	return (0);
+}
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/crypto/crypto_dh.h tarsnap-autoconf-1.0.34/libcperciva/crypto/crypto_dh.h
--- tarsnap-autoconf-1.0.33/libcperciva/crypto/crypto_dh.h	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/crypto/crypto_dh.h	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,43 @@
+#ifndef _CRYPTO_DH_H_
+#define _CRYPTO_DH_H_
+
+#include <stdint.h>
+
+/* Sizes of Diffie-Hellman private, public, and exchanged keys. */
+#define CRYPTO_DH_PRIVLEN	32
+#define CRYPTO_DH_PUBLEN	256
+#define CRYPTO_DH_KEYLEN	256
+
+/**
+ * crypto_dh_generate_pub(pub, priv):
+ * Compute ${pub} equal to 2^(2^258 + ${priv}) in Diffie-Hellman group #14.
+ */
+int crypto_dh_generate_pub(uint8_t[CRYPTO_DH_PUBLEN],
+    const uint8_t[CRYPTO_DH_PRIVLEN]);
+
+/**
+ * crypto_dh_generate(pub, priv):
+ * Generate a 256-bit private key ${priv}, and compute ${pub} equal to
+ * 2^(2^258 + ${priv}) mod p where p is the Diffie-Hellman group #14 modulus.
+ * Both values are stored as big-endian integers.
+ */
+int crypto_dh_generate(uint8_t[CRYPTO_DH_PUBLEN], uint8_t[CRYPTO_DH_PRIVLEN]);
+
+/**
+ * crypto_dh_compute(pub, priv, key):
+ * In the Diffie-Hellman group #14, compute ${pub}^(2^258 + ${priv}) and
+ * write the result into ${key}.  All values are big-endian.  Note that the
+ * value ${pub} is the public key produced the call to crypto_dh_generate
+ * made by the *other* participant in the key exchange.
+ */
+int crypto_dh_compute(const uint8_t[CRYPTO_DH_PUBLEN],
+    const uint8_t[CRYPTO_DH_PRIVLEN], uint8_t[CRYPTO_DH_KEYLEN]);
+
+/**
+ * crypto_dh_sanitycheck(pub):
+ * Sanity-check the Diffie-Hellman public value ${pub} by checking that it
+ * is less than the group #14 modulus.  Return 0 if sane, -1 if insane.
+ */
+int crypto_dh_sanitycheck(const uint8_t[CRYPTO_DH_PUBLEN]);
+
+#endif /* !_CRYPTO_DH_H_ */
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/crypto/crypto_dh_group14.c tarsnap-autoconf-1.0.34/libcperciva/crypto/crypto_dh_group14.c
--- tarsnap-autoconf-1.0.33/libcperciva/crypto/crypto_dh_group14.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/crypto/crypto_dh_group14.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,46 @@
+#include <stdint.h>
+
+#include "crypto_dh_group14.h"
+
+/**
+ * This is the big-endian representation of
+ * p = 2^2048 - 2^1984 + 2^64 * floor(2^1918 pi + 124476) - 1
+ * where the value 124476 is chosen to be the least positive integer such
+ * that both p and (p - 1)/2 are prime.  Diffie-Hellman operations are done
+ * in the group of quadratic residues modulo p, and the integer 2 is a
+ * generator of this group.
+ */
+uint8_t crypto_dh_group14[256] = {
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
+	0xc9, 0x0f, 0xda, 0xa2, 0x21, 0x68, 0xc2, 0x34,
+	0xc4, 0xc6, 0x62, 0x8b, 0x80, 0xdc, 0x1c, 0xd1,
+	0x29, 0x02, 0x4e, 0x08, 0x8a, 0x67, 0xcc, 0x74,
+	0x02, 0x0b, 0xbe, 0xa6, 0x3b, 0x13, 0x9b, 0x22,
+	0x51, 0x4a, 0x08, 0x79, 0x8e, 0x34, 0x04, 0xdd,
+	0xef, 0x95, 0x19, 0xb3, 0xcd, 0x3a, 0x43, 0x1b,
+	0x30, 0x2b, 0x0a, 0x6d, 0xf2, 0x5f, 0x14, 0x37,
+	0x4f, 0xe1, 0x35, 0x6d, 0x6d, 0x51, 0xc2, 0x45,
+	0xe4, 0x85, 0xb5, 0x76, 0x62, 0x5e, 0x7e, 0xc6,
+	0xf4, 0x4c, 0x42, 0xe9, 0xa6, 0x37, 0xed, 0x6b,
+	0x0b, 0xff, 0x5c, 0xb6, 0xf4, 0x06, 0xb7, 0xed,
+	0xee, 0x38, 0x6b, 0xfb, 0x5a, 0x89, 0x9f, 0xa5,
+	0xae, 0x9f, 0x24, 0x11, 0x7c, 0x4b, 0x1f, 0xe6,
+	0x49, 0x28, 0x66, 0x51, 0xec, 0xe4, 0x5b, 0x3d,
+	0xc2, 0x00, 0x7c, 0xb8, 0xa1, 0x63, 0xbf, 0x05,
+	0x98, 0xda, 0x48, 0x36, 0x1c, 0x55, 0xd3, 0x9a,
+	0x69, 0x16, 0x3f, 0xa8, 0xfd, 0x24, 0xcf, 0x5f,
+	0x83, 0x65, 0x5d, 0x23, 0xdc, 0xa3, 0xad, 0x96,
+	0x1c, 0x62, 0xf3, 0x56, 0x20, 0x85, 0x52, 0xbb,
+	0x9e, 0xd5, 0x29, 0x07, 0x70, 0x96, 0x96, 0x6d,
+	0x67, 0x0c, 0x35, 0x4e, 0x4a, 0xbc, 0x98, 0x04,
+	0xf1, 0x74, 0x6c, 0x08, 0xca, 0x18, 0x21, 0x7c,
+	0x32, 0x90, 0x5e, 0x46, 0x2e, 0x36, 0xce, 0x3b,
+	0xe3, 0x9e, 0x77, 0x2c, 0x18, 0x0e, 0x86, 0x03,
+	0x9b, 0x27, 0x83, 0xa2, 0xec, 0x07, 0xa2, 0x8f,
+	0xb5, 0xc5, 0x5d, 0xf0, 0x6f, 0x4c, 0x52, 0xc9,
+	0xde, 0x2b, 0xcb, 0xf6, 0x95, 0x58, 0x17, 0x18,
+	0x39, 0x95, 0x49, 0x7c, 0xea, 0x95, 0x6a, 0xe5,
+	0x15, 0xd2, 0x26, 0x18, 0x98, 0xfa, 0x05, 0x10,
+	0x15, 0x72, 0x8e, 0x5a, 0x8a, 0xac, 0xaa, 0x68,
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff
+};
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/crypto/crypto_dh_group14.h tarsnap-autoconf-1.0.34/libcperciva/crypto/crypto_dh_group14.h
--- tarsnap-autoconf-1.0.33/libcperciva/crypto/crypto_dh_group14.h	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/crypto/crypto_dh_group14.h	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,9 @@
+#ifndef _CRYPTO_DH_GROUP14_H_
+#define _CRYPTO_DH_GROUP14_H_
+
+#include <stdint.h>
+
+/* Diffie-Hellman group #14, from RFC 3526. */
+extern uint8_t crypto_dh_group14[];
+
+#endif /* !_CRYPTO_DH_GROUP14_H_ */
